"use strict";Object.defineProperty(exports, "__esModule", {value: true});var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/index.ts
var _fs = require('fs');
var _core = require('@babel/core');
function transform(code, rawOptions) {
  const _a = rawOptions, { name: callerName } = _a, babelOptions = __objRest(_a, ["name"]);
  const options = _core.loadOptions.call(void 0, __spreadProps(__spreadValues({}, babelOptions), {
    caller: {
      name: callerName,
      supportsStaticESM: true
    }
  }));
  if (!options) {
    return { code };
  }
  return _core.transformSync.call(void 0, code, options);
}
var VITE_PLUGIN_NAME = "vite-plugin-babel-compiler";
var ESBUILD_PLUGIN_NAME = "esbuild-plugin-babel-compiler";
function PluginDecorator(rawOptions) {
  const { apply, babel: options } = rawOptions;
  return {
    name: VITE_PLUGIN_NAME,
    apply,
    enforce: "pre",
    config(config) {
      var _a;
      if (!config.optimizeDeps)
        config.optimizeDeps = {};
      if (!config.optimizeDeps.esbuildOptions)
        config.optimizeDeps.esbuildOptions = {};
      if (!((_a = config.optimizeDeps.esbuildOptions) == null ? void 0 : _a.plugins))
        config.optimizeDeps.esbuildOptions.plugins = [];
      config.optimizeDeps.esbuildOptions.plugins.push({
        name: ESBUILD_PLUGIN_NAME,
        setup(build) {
          build.onLoad({
            filter: new RegExp(`(${_core.DEFAULT_EXTENSIONS.join("|")})$`)
          }, ({ path }) => {
            var _a2;
            const raw = _fs.readFileSync.call(void 0, path, "utf-8");
            const { code } = (_a2 = transform(raw, __spreadProps(__spreadValues({}, options), {
              name: ESBUILD_PLUGIN_NAME,
              filename: path
            }))) != null ? _a2 : {};
            return {
              contents: code != null ? code : ""
            };
          });
        }
      });
    },
    transform(code, id) {
      var _a;
      const { code: transformedCode, map } = (_a = transform(code, __spreadProps(__spreadValues({}, options), {
        name: VITE_PLUGIN_NAME,
        filename: id
      }))) != null ? _a : {};
      return {
        code: transformedCode != null ? transformedCode : "",
        map
      };
    }
  };
}
var src_default = PluginDecorator;



exports.default = src_default; exports.transform = transform;
